import { AbstractControl, FormBuilder, FormControl, FormGroup } from '@angular/forms';
export declare type FormGroupControlsOf<T> = {
    [P in keyof T]: FormControl | FormGroup;
};
export declare abstract class FormGroupTypeSafe<T> extends FormGroup {
    value: T | undefined;
    abstract getSafe(propertyFunction: (typeVal: T) => any): AbstractControl;
    abstract setControlSafe(propertyFunction: (typeVal: T) => any, control: AbstractControl): void;
}
export declare class FormControlTypeSafe<T> extends FormControl {
    value: T | undefined;
}
export declare const generateGetSafeFunction: <T extends unknown>(gr: FormGroupTypeSafe<T>) => (propertyFunction: (typeVal: T) => any) => AbstractControl;
export declare const generateSetControlSafeFunction: <T extends unknown>(gr: FormGroupTypeSafe<T>) => (propertyFunction: (typeVal: T) => any, control: AbstractControl) => void;
export declare class FormBuilderTypeSafe extends FormBuilder {
    group<T>(controlsConfig: FormGroupControlsOf<T>, extra?: {
        [key: string]: any;
    } | null): FormGroupTypeSafe<T>;
}
