"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
const getPropertyName_1 = require("./getPropertyName");
class FormGroupTypeSafe extends forms_1.FormGroup {
}
exports.FormGroupTypeSafe = FormGroupTypeSafe;
// tslint:disable-next-line:max-classes-per-file
class FormControlTypeSafe extends forms_1.FormControl {
}
exports.FormControlTypeSafe = FormControlTypeSafe;
exports.generateGetSafeFunction = (gr) => {
    return (propertyFunction) => {
        const getStr = getPropertyName_1.getPropertyName(propertyFunction.toString());
        const p = gr.get(getStr);
        return p;
    };
};
exports.generateSetControlSafeFunction = (gr) => {
    return (propertyFunction, control) => {
        const getStr = getPropertyName_1.getPropertyName(propertyFunction.toString());
        gr.setControl(getStr, control);
    };
};
// tslint:disable-next-line: max-classes-per-file
let FormBuilderTypeSafe = class FormBuilderTypeSafe extends forms_1.FormBuilder {
    // override group to be type safe
    group(controlsConfig, extra) {
        /* NOTE the return FormGroupTypeSafe<T> */
        // instantiate group from angular type
        const gr = super.group(controlsConfig, extra);
        if (gr) {
            // implement getSafe method
            gr.getSafe = exports.generateGetSafeFunction(gr);
            // implement setControlSafe
            gr.setControlSafe = exports.generateSetControlSafeFunction(gr);
        }
        return gr;
    }
};
FormBuilderTypeSafe = __decorate([
    core_1.Injectable()
], FormBuilderTypeSafe);
exports.FormBuilderTypeSafe = FormBuilderTypeSafe;
